--- chan_sip.c.old	2004-02-21 03:06:15.000000000 +0200
+++ chan_sip.c	2004-02-21 03:09:39.000000000 +0200
@@ -2906,10 +2906,20 @@
 	if (p->owner && p->owner->callerid) {
 		strcpy(cid, p->owner->callerid);
 		ast_callerid_parse(cid, &n, &l);
-		if (l) 
-			ast_shrink_phone_number(l);
-		if (!l || !ast_isphonenumber(l))
-				l = callerid;
+/*
+ * If there is a domain part in the callerid of the user,
+ * use this caller id as if it was a fromdomain option for
+ * the outgoing call. This allows the type=user SIP entities
+ * to have a fromdomain capability.
+ *
+ */
+		if (l && !strlen(p->fromdomain)) {
+			char *at = strchr(l, '@');
+			if(at) {
+				strcpy(p->fromdomain, &at[1]);
+				*at = '\0';
+			}
+		}
 	}
 	/* if user want's his callerid restricted */
 	if (p->restrictcid)
@@ -4198,14 +4208,23 @@
 	} else
 		of += 4;
 	/* Get just the username part */
-	if ((c = strchr(of, '@')))
-		*c = '\0';
 	if ((c = strchr(of, ':')))
 		*c = '\0';
 	if (*calleridname)
 		sprintf(p->callerid,"\"%s\" <%s>",calleridname,of);
 	else
 		strncpy(p->callerid, of, sizeof(p->callerid) - 1);
+	
+/*
+ * Remove the domain part after it has been stored in the
+ * callerid. This allows incoming calls from unknown users
+ * (not users and not peers) to maintain their original
+ * callerid which will be forwarded to the other end.
+ *
+ */
+	if ((c = strchr(of, '@')))
+		*c = '\0';
+	
 	if (!strlen(of))
 			return 0;
 	ast_mutex_lock(&userl.lock);
